<template>
  <div class="directions-clustering">
    <div v-if="isLoading" class="directions-clustering__loader">
      <ObLoader
          :width="10"
          :height="10"
          :duration="2"
          class="directions-clustering__loader-icon"
      />
    </div>
    <template v-if="groups.length">
      <ObFunctionalPanel
          :columns="columns"
          :loading="isLoading"
          :show-refresh="false"
          :show-edit="false"
          :show-group="false"
          :show-sort="false"
          :showColumnFilter="false"
          :showAddButton="true"
          addButtonText="Добавить группу направлений"
          @add="onAddGroup"
          @search="onSearch"
      />

      <div class="accordion-header" @click="onAccordionHeaderClick">
        <i class="chevron icon chevron-down" :class="[accOpen ? 'opened' : 'closed']" />
        <div class="accordion-header__item title">
          Наименование
        </div>
        <div class="accordion-header__item date">
          Создано
        </div>
        <div class="accordion-header__item autor">
          Автор
        </div>
      </div>

      <div
        class="baseprices-clustering-groups"
        v-for="(group) in groups"
        :key="group.uuid">

        <ObAccordion
            :title="group.title"
            :icon="getIconClass(group.transportationWay)"
            :isEditable="true"
            :isOpen="accOpen"
            @change="changeGroupTitle($event, group)"
        >
          <template v-slot:title-content>
            <div class="accordion-title-item date">
              {{ group.createdAt | date('DD.MM.YYYY') }}
            </div>
            <div class="accordion-title-item autor">
              {{ group.userInfo }}
            </div>
            <div class="accordion-title-item color-blue services-count">
              <template v-if="group.directions">
                Направлений: {{ group.directions.length }}
              </template>
            </div>
            <i title="Удалить" class="accordion-title-item delete-icon icon close-sm" @click.stop="deleteGroup(group)" />
          </template>

          <template v-if="group.directions">
            <div class="baseprices-clustering-directions">

              <div class="accordion-header" @click="onSubAccordionHeaderClick(group.uuid)">
                <i class="chevron icon chevron-down" :class="[subAccOpen[group.uuid] ? 'opened' : 'closed']" />
                <div class="accordion-header__item title">
                  Откуда
                </div>
              </div>

              <div
                v-for="(direction, index) in group.directions"
                :key="direction.uuid">

                <ObAccordion
                  :title="getLocationTitleFromUuid(direction.locationFromUuid)"
                  :icon="getLocationIconFromUuid(direction.locationFromUuid)"
                  :isOpen="subAccOpen[group.uuid]"
                >
                  <template v-slot:title-content>
                    <i title="Удалить" class="accordion-title-item delete-icon icon close-sm" @click.stop="deleteDirection(direction, group.uuid)" />
                  </template>

                  <ObTable
                    v-if="direction.locationsTo"
                    :ref="'baseprices-clustering-groups-grid-' + index"
                    :items="direction.locationsTo"
                    :columns="columns"
                    :footer-disabled="true"
                    :isHeader="false"
                    data-qa="tableDirectionsClusterBP"
                  >
                    <template class="w100" v-slot:service="{ data }">
                      <div class="service-item">
                        <div class="service-item__title">
                          <div class="location">
                            <i class="icon navigation-arrow"></i>
                            <i class="icon" :class="getLocationIconFromUuid(data.item.locationUuid)"></i>
                            {{ getLocationTitleFromUuid(data.item.locationUuid) }} <span class="direction">{{data.item.distance}} км</span>
                          </div>
                        </div>
                        <i title="Удалить" class="delete-icon icon close-sm" @click="deleteLocation(data.item, direction.uuid, group.uuid)" />
                      </div>
                    </template>
                  </ObTable>

                  <ObButton
                      class="addServiceButton"
                      label="Редактировать список"
                      type="flat"
                      icon="plus"
                      @click="editDirection(direction, group.uuid)"
                      data-qa="buttonAddServiceBP"
                  />

                </ObAccordion>
              </div>
            </div>
          </template>

          <ObButton
              class="addDirectionButton"
              label="Добавить направление"
              type="primary"
              icon="plus"
              @click="addDirection(group)"
              data-qa="buttonAddDirectionBP"
          />
        </ObAccordion>
      </div>

      <div class="table-footer">
        <ObPagination
            :page="pagination.page_num"
            :count="pagination.total_elements"
            :page-limit="pagination.page_size"
            @on-change="clickPage"
        />
      </div>

    </template>
    <template v-else>
      <div class="no-items">
        <p>Здесь вы сможете настраивать кластеризацию для направлений ваших перевозок. Для этого добавьте хотя бы одну группу направлений</p>
        <ObButton
            class="addGroupButton"
            label="Добавить группу направлений"
            type="flat"
            icon="plus"
            @click="onAddGroup"
            data-qa="buttonAddGroupBP"
        />
      </div>
    </template>

    <ObModal
        ref="basePriceDirectionsGroupAdd"
        title="Группа направлений"
        titleSecond="Добавление"
        custom-class="modal-large"
    >
      <BasePriceDirectionGroupForm
          :initData="selectedGroup"
          @save="onGroupSave"
      />
    </ObModal>

    <ObModal
        ref="basePriceDirectionForm"
        title="Направление"
        :titleSecond="formIsEdit ? 'Редактирование' : 'Добавление'"
        custom-class="modal-large"
        @closed="closeDirectionPopup"
        data-qa="modalDirectionBP"
    >
      <BasePriceDirectionForm
          :data-source="selectedDirection"
          :is-edit="formIsEdit"
          @save="onDirectionSave"
      />
    </ObModal>

    <ObModal
        ref="deleteGroupModal"
        :title="isDirectionsInGroup? 'В этой группе уже добавлены направления' : 'Удалить группу?'"
        size="medium"
        :is-show-controls="true"
        ok-text="Удалить"
        @submit="onDeleteGroup"
        :is-error="Boolean(isDirectionsInGroup)"
        data-qa="modalDeleteGroupBP"
    >
      <div v-if="directionForDelete" class="del-direction">{{ groupForDelete.title }}</div>
      <template v-if="isDirectionsInGroup">
        <p>Направлений: {{isDirectionsInGroup}}</p>
        <p>Вы точно хотите удалить группу?</p>
      </template>
      <template v-else>
        <p>Вы точно хотите удалить группу?</p>
      </template>
    </ObModal>

    <ObModal
        ref="deleteDirectionModal"
        :title="isLocationsInDirection? 'В этом направлении уже добавлены локации' : 'Удалить направление?'"
        size="medium"
        :is-show-controls="true"
        ok-text="Удалить"
        :isError="Boolean(isLocationsInDirection)"
        @submit="onDeleteDirection"
        data-qa="modalDeleteDirectionBP"
    >
      <div v-if="directionForDelete" class="del-direction">{{ directionForDelete.title }}</div>
      <template v-if="isLocationsInDirection">
        <p>Локаций: {{ isLocationsInDirection }}</p>
        <p>Вы точно хотите удалить направление?</p>
      </template>
      <template v-else>
        <p>Вы точно хотите удалить направление?</p>
      </template>
    </ObModal>

    <ObModal
        ref="deleteLocationModal"
        title="Удаление"
        size="medium"
        :is-show-controls="true"
        ok-text="Удалить"
        @submit="onDeleteLocation"
        data-qa="modalDeleteLocationBP"
    >
      Вы точно хотите удалить локацию: "<span v-if="locationForDelete" class="color-blue">{{ getLocationTitleFromUuid(locationForDelete.locationUuid) }}</span>" ?
    </ObModal>

  </div>
</template>

<script>
import api from '@/api';
import ObTable from 'common-components/src/obComponents/obTable';
import ObModal from 'common-components/src/obComponents/obModal';
import ObFunctionalPanel from 'common-components/src/obComponents/obFuncPanel';
import ObPagination from 'common-components/src/obComponents/obPagination';
import ObButton from 'common-components/src/obComponents/obButton';
import ObLoader from 'common-components/src/obComponents/obLoader';
import ObAccordion from '../components/accordion';
import BasePriceDirectionGroupForm from '../modal/directionGroup';
import BasePriceDirectionForm from '../modal/directionForm';
import {mapActions, mapGetters} from "vuex";

export default {
  name: 'BasePricesClusteringTransportType',

  components: {
    ObTable,
    ObModal,
    ObFunctionalPanel,
    ObAccordion,
    ObButton,
    ObLoader,
    ObPagination,
    BasePriceDirectionGroupForm,
    BasePriceDirectionForm,
  },
  data() {
    return {
      accOpen: false,
      subAccOpen: {},
      isLoading: false,
      selectedGroup: {},
      selectedDirection: {},
      directionForDelete: null,
      groupForDelete: null,
      locationForDelete: null,
      hideInactive: false,
      groups: [],
      usersInfo: [],
      formIsEdit: false,
      pagination: {
        page_num: 0,
        page_size: 20,
        total_elements: 0
      }
    }
  },
  computed: {
    ...mapGetters({
      locations: 'base_prices/locations',
      getLocationTitleFromUuid: 'base_prices/getLocationTitleFromUuid',
      getLocationIconFromUuid: 'base_prices/getLocationIconFromUuid',
    }),
    columns () {
      return [
        {
          title: 'Наименование',
          key: 'title',
          slotName: 'service',
        },
      ]
    },
    isLocationsInDirection() {
      return this?.directionForDelete?.locationsTo?.length;
    },
    isDirectionsInGroup() {
      return this?.groupForDelete?.directions?.length;
    }
  },
  async created() {
    await this.loadData();
  },
  methods: {
    ...mapActions({
      getLocations: 'base_prices/getLocations',
    }),
    async loadData() {
      try {
        this.isLoading = true;
        let data = await api.base_prices_clustering.getDirectionsGroups( { page_size: this.pagination.page_size, page_num: this.pagination.page_num });
        if (data.content && data.content.length) {
          let authorUuids = [];
          data.content.filter((e, i ,a) => {
            let res = a.findIndex((t) => t.authorUuid === e.authorUuid) === i;
            if (res) {
              authorUuids.push(data.content[i].authorUuid)
            }
            return res;
          });
          let usersInfo = await api.adminPanel.users.getUsersInfo(authorUuids)
          if (usersInfo.list.length) {
            this.usersInfo = usersInfo.list;
          }

          // форматируем и дополняем данные
          data.content = data.content.map((item) => {
            return {
              ...item,
              userInfo: this.getUserInfo(item.authorUuid),
            }
          });

          this.pagination.page_num = data.pageNum;
          this.pagination.page_size = data.pageSize;
          this.pagination.total_elements = data.totalElements;

          this.groups = data.content;

          await this.getLocationsFromData(this.groups);

        } else {
          this.groups = [];
        }
        this.isLoading = false;
      } catch (e) {
        console.error(e);
        this.isLoading = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    changeActive() {
    },
    onSearch() {
    },
    onAddGroup() {
      this.$refs.basePriceDirectionsGroupAdd.open();
    },
    onGroupSave() {
      this.$refs.basePriceDirectionsGroupAdd.close();
      this.loadData();
    },
    deleteDirection(direction, groupUuid) {
      this.directionForDelete = direction;
      this.directionForDelete.groupUuid = groupUuid;
      this.$refs.deleteDirectionModal.open();
    },
    async onDeleteDirection() {
      this.$refs.deleteDirectionModal.close();
      try {
        await api.base_prices_clustering.deleteDirection(this.directionForDelete.groupUuid, this.directionForDelete.uuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Направление удалено`
        });
        await this.loadData();
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка удаления направления'});
      }
      this.directionForDelete = null;
    },
    deleteGroup(group) {
      this.groupForDelete = group;
      this.$refs.deleteGroupModal.open();
    },
    async onDeleteGroup() {
      this.$refs.deleteGroupModal.close();
      try {
        await api.base_prices_clustering.deleteDirectionGroup(this.groupForDelete.uuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Группа удалена`
        });
        await this.loadData();
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка удаления группы'});
      }
      this.deleteGroupModal = null;
    },
    deleteLocation(item, directionUuid, groupUuid) {
      this.locationForDelete = item;
      this.locationForDelete.directionUuid = directionUuid;
      this.locationForDelete.groupUuid = groupUuid;
      this.$refs.deleteLocationModal.open();
    },
    async onDeleteLocation() {
      this.$refs.deleteLocationModal.close();
      try {
        await api.base_prices_clustering.deleteLocation(this.locationForDelete.locationUuid, this.locationForDelete.directionUuid, this.locationForDelete.groupUuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Локация удалена`
        });
        await this.loadData();
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка удаления локации'});
      }
      this.locationForDelete = null;
    },
    async changeGroupTitle(title, group) {
      if (!title || !group) {
        return false;
      }
      try {
        await api.base_prices_clustering.updateDirectionGroup(group.uuid, title);
        this.$notification({
          type: 'system_notification_success',
          message: `Группа переименована`
        });
        await this.loadData();
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка переименования группы'});
      }
    },
    addDirection(group) {
      this.formIsEdit = false;
      this.selectedDirection = {
        groupUuid: group.uuid,
        locationFromUuid: null,
        locationToUuid: null,
      };
      this.$refs.basePriceDirectionForm.show();
    },
    closeDirectionPopup() {
      this.$refs.basePriceDirectionForm.hide();
    },
    onDirectionSave() {
      this.$refs.basePriceDirectionForm.hide();
      this.loadData();
    },
    editDirection (direction, groupUuid) {
      this.formIsEdit = true;
      let locationsTo = [];
      if(direction.locationsTo && direction.locationsTo.length){
        direction.locationsTo.forEach(el => {
          locationsTo.push(el.locationUuid);
        });
      }
      this.selectedDirection = {
        groupUuid: groupUuid,
        directionUuid: direction.uuid,
        locationFromUuid: [direction.locationFromUuid],
        locationToUuid: locationsTo,
      };
      this.$refs.basePriceDirectionForm.show();
    },
    onAccordionHeaderClick() {
      this.accOpen = !this.accOpen;
    },
    onSubAccordionHeaderClick(groupUuid) {
      this.$set(this.subAccOpen, groupUuid, Boolean(!this.subAccOpen[groupUuid]));
    },
    clickPage(page) {
      this.pagination.page_num = page;
      this.loadData();
    },
    getUserInfo(userUuid) {
      if (this.usersInfo.length) {
        let userData = this.usersInfo.find(user => user.uuid === userUuid);
        if (userData) {
          return userData.firstname + ' ' + userData.lastname;
        }
      }
      return 'Не найден';
    },
    getIconClass(transportationWay) {
      let icon;
      switch (transportationWay) {
        case 'CONTAINER':
          icon = 'container';
          break;
        case 'RAIL':
          icon = 'carriage';
          break;
        default:
          icon = 'truck-sm';
      }
      return icon;
    },
    async getLocationsFromData(data) {
      let locations = [];
      if(data.length) {
        data.forEach(group => {
          if(group.directions && group.directions.length) {
            group.directions.forEach(direction => {
              locations.push(direction.locationFromUuid);
              if(direction.locationsTo && direction.locationsTo.length) {
                direction.locationsTo.forEach(loc => {
                  locations.push(loc.locationUuid);
                });
              }
            });
          }
        });
        await this.getLocations(locations);
      }
    },
  },
}
</script>

<style lang="scss" scoped>

.directions-clustering{
  position: relative;

  &__loader {
    position: absolute;
    background: $background-white;
    opacity: 0.8;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 100%;
    &-icon {
      position: absolute;
      top: calc(50% - 20px);
      left: calc(50% - 20px);
      width: 40px;
      height: 40px;
    }
  }
}

.baseprices-clustering-directions{
  margin: 10px 0 10px 30px;
}

.service-item {
  display: flex;
  align-items: center;
  justify-content: space-between;
  width: 100%;

  &__title {
    margin-left: 80px;
  }
}

.addDirectionButton {
  margin-top: 10px;
  margin-left: 83px;
  span {
    font-size: 14px;
  }
}

.addLocationButton{
  margin-left: 83px;
  span {
    font-size: 14px;
  }
  i {
    color: #9DA0AC;
    transition: all 0.2s linear;
  }

  &:hover{
    i {
      color: $blue-dust;
    }
  }
}

.location {
  i {
    margin-right: 15px;
    display: inline-block;
  }

  .icon {
    color: $blue-dust;
  }

  .navigation-arrow{
    color: #9DA0AC;
    transform: rotate(180deg);
    font-size: 15px;
  }

  .direction{
    margin-left: 10px;
    color: $gray-slate;
  }
}

.color-blue {
  color: $blue-dust;
}

.del-direction{
  color: $cobalt-black;
  font-size: 16px;
  font-weight: 700;
  margin-top: 30px;
  margin-bottom: 10px;
}

</style>